module Control.HM.Examples.VS.Concentrator where


import Control.HM.Tensors 
import Control.HM.Encapsulate

import Pointless.Combinators hiding ((\/))
import Data.HListExtras
import Control.Monad.Trans
import Control.Monad.State
import System.IO.Unsafe
import Maybe



data Reset; reset = _L :: Reset; instance Show Reset where show _ = "reset"

data Vote; vote = _L :: Vote; instance Show Vote where show _ = "vote"


concentrator :: Int -> HCons (Reset, Either Int () -> Maybe (Int, Either () Bool)) 
                       (HCons (Vote, Either Int () -> Maybe (Int, Either () Bool)) HNil)

concentrator = \st -> (reset, resetf st) .*. (vote, votef st) .*. HNil
    where
        resetf st (Left n) = Just (n, Left ())
        votef st (Right ci) = Just (st-1, Right $ st-1 == 1)



-- to test the concentrator
cTest () = (@.) ((->>) $ concentrator)

