module Control.HM.Examples.VS.VotingSystem where

import Control.HM.Examples.VS.VotingPad
import Control.HM.Examples.VS.Concentrator
import Control.HM.Examples.VS.Codiagonal

import Control.HM.Tensors 
import Control.HM.Encapsulate

import Pointless.Combinators hiding ((\/))
import Data.HListExtras
import Control.Monad.Trans
import Control.Monad.State
import System.IO.Unsafe




-- creating N placies to vote (this case 3)
vp3 () = (vp |+| vp |+| vp) |.| cod

vp3Test () = (@.) ((->>) $ vp3 ())




-- s+
apo :: Either () (Either () Bool) -> Either (Either () Bool) ()
apo (Left a) = Right a
apo (Right b) = Left b

-- a+
api :: SUM1' -> SUM1
api (Left (Left a)) = Left a 
api (Left (Right b)) = Right $ Left b
api (Right c) = Right $ Right c


type SUM1 = Either (Either (Either () ()) ()) (Either Int ())  
type SUM1' = Either (Either (Either (Either () ()) ()) Int) ()


votingSystem () = wrap ((vp3 ()) |+| concentrator) api apo






data Emit1; emit1 = _L :: Emit1; instance Show Emit1 where show _ = "emit1"
data Emit2; emit2 = _L :: Emit2; instance Show Emit2 where show _ = "emit2"
data Emit3; emit3 = _L :: Emit3; instance Show Emit3 where show _ = "emit3"


vsHooked () = hook (votingSystem ()) hp
    where
     hp = (emit1, (LEFT (LEFT (LEFT emit), codT), RIGHT vote)) .*. 
          (emit2, (LEFT (LEFT (RIGHT emit), codT), RIGHT vote)) .*. 
          (emit3, (LEFT (RIGHT emit, codT), RIGHT vote)) .*. HNil


vsHTest () = (@.) ((->>) $ vsHooked ())

{-
*Control.ComponentsTL.Examples.VS.VotingSystem> 
                            vsHTest () ((((4,3),5),()),10) emit3 (Left (Left (Right ())))

Just (((((4,3),4),()),9),(emit3,Left (Right False)))
-}



type In = Either (Either (Either (Either () ()) ()) Int) ()

instance ( Sum Emit1 s In, Sum Emit2 s In, Sum Emit3 s In, Sum (RIGHT Reset) s In ) => Read s
    where
        readsPrec _ "emit1" = [(inject emit1 (Left $ Left $ Left $ Left ()), "")]
        readsPrec _ "emit2" = [(inject emit2 (Left $ Left $ Left $ Right ()), "")]
        readsPrec _ "emit3" = [(inject emit3 (Left $ Left $ Right ()), "")]
        readsPrec _ ('r':'e':'s':'e':'t':' ':n) = 
            [(inject (RIGHT reset) (Left $ Right (read n :: Int)), "")]



vsAnimation () = evalStateT $ doCompIO ((->>) $ vsHooked ()) 

{-
*Control.ComponentsTL.Examples.VS.VotingSystem> vsAnimation () ((((4,3),5),()),10)

Action: emit1
(emit1,Left (Right False))

Action: emit2
(emit2,Left (Right False))

Action: reset 3
(*** Exception: Prelude.undefined
-}






-- lixo

--vsAnime mode l = runCamilaT $ mode $ anime () l

instance MonadIO Maybe
    where
        liftIO x = Just (unsafePerformIO x)


{-
-- the lift part is not necessary because our output it's always the same
lif () = cpLift (\/) lift_

tlif () = (@.) ((->>) $ lif ())

-- *Camila.ComponentsTL.VotingSystem> showr $ tlif () () lift_  (Left 'a')
-- "((),(Lift_,'a'))"


-- nao e necessario a parte do lift ...
vs2 () = (vp |+| vp) |.| (cpLift either_ lift_)

tvs2 () = (@.) ((->>) $ vs2 ())
-}
