{-# OPTIONS -fglasgow-exts #-}

module Pointless.Examples.Observe where

import Pointless.Combinators
import Pointless.Functors
import Pointless.Isomorphisms
import Pointless.RecursionPatterns
import Pointless.Observe.RecursionPatterns
import Pointless.Observe.Functors
import Pointless.Examples.Examples (one, mult, part, cat, Tree(..))
import Debug.Observe

fib :: Int -> Int
fib = hyloO (_L :: Mu (Const One :+: Id :*: Id)) f g
    where g = (bang -|- pred /\ pred . pred) . ((<=1)?)
	  f = one \/ plus

qsort :: (Observable a, Ord a) => [a] -> [a]
qsort = hyloO (_L::Tree a) f g
    where g = (id -|- fst /\ part) . out
	  f = nil \/ cat . (id >< cons) . assocr . (swap >< id) . assocl

fact :: Int -> Int
fact = paraO (_L::Int) f
    where f = one \/ mult . (id >< succ)

fact' :: Int -> Int
fact' = hyloX (_L :: [Int]) f g
    where g = (id -|- succ /\ id) . out
          f = one \/ mult

len :: Observable a => [a] -> Int
len = cataO (_L::Mu (Const One :+: Const a :*: Id)) g
    where g = zero \/ succ . snd

cauda :: (Observable a, Show a) => [a] -> [a]
cauda = paraO (_L::[a]) (nil \/ snd . snd)

plus :: (Int,Int) -> Int
plus = accumO (_L::Int) t f
    where t = (fst -|- id >< succ) . distl
	  f = (snd \/ fst) . distl